﻿Imports System.IO
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Threading
Imports frm = System.Windows.Forms
Imports mshtml


Class MainWindow
#Region "Dims"
    Dim curFileName As String = ""
    Dim bLoaded As Boolean
    Dim n As Int32 = 1
    Public WithEvents wb As New C_WebBrowser(WebBrowser1)
    Dim factor As Single = 1.0
    Dim iCurGo2, lstGo2 As Int32
    'Dim vN(-1) As Int32
    Dim sTbVar(-1) As String
    Dim sTbQry(-1), vsResultGo2HTML(-1), vsResultGo3(-1) As String
    Dim mP As New matrixParser
    Dim cfg As New Config
    Dim oVars As VarsAndFns
    Dim oldsVar As String
    Dim mtx As New System.Threading.Mutex()
    Dim sComments() As String
    Dim vNames() As String, vValues() As Double
    Dim th As System.Threading.Thread
    Dim outputWin As Output
    Dim infoHelp As System.Windows.Resources.StreamResourceInfo
    Dim filepathCurrOptions As String = Microsoft.VisualBasic.CurDir + "\config.txt"
    Dim graph1 As Graph
    Dim bAppend As Boolean

#End Region

#Region "Options"

    Private Sub Open_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        'Me.OpenFile(False)
    End Sub
    Private Sub OpenHTML_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Me.OpenHTMLFile(False)
    End Sub
    Private Sub AppendFile_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        'Me.OpenFile(True)
    End Sub
    Private Sub Save_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        'Save()
    End Sub
    Private Sub SaveHTML_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        SaveHTML()
    End Sub
    Private Sub RestoreDefault_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            setDefaultOptions()
            Dim e1 As String = toStrOptions()
            Dim fs As New FileStream(filepathCurrOptions, FileMode.Create)
            Dim sw As New StreamWriter(fs)
            sw.Write(e1)
            sw.Close()
            fs.Close()
            updateStatusBar()

        Catch ex As Exception

        End Try
    End Sub
    Private Sub SaveCurrent_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try

            Dim e1 As String = toStrOptions()
            Dim fs As New FileStream(filepathCurrOptions, FileMode.Create)
            Dim sw As New StreamWriter(fs)
            sw.Write(e1)
            sw.Close()
            fs.Close()
        Catch ex As Exception
            If bLoaded Then
                MsgBox(ex.ToString)
            End If
        End Try

    End Sub
    Private Sub GoFn_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Dim ev As New Evaluate
        Try
            If sTbQry.Length Then
                ev.TBEvalFn.Text = sTbQry(sTbQry.Length - 1)
            End If
        Catch ex As Exception

        End Try
        ev.Show()
    End Sub
    Function toStrOptions() As String
        Dim e1() As String = Nothing
        Try
            e1 = New String() {
                chkClear.IsChecked.ToString,
                chkEng.IsChecked.ToString,
                chkIgnoreCase.IsChecked.ToString,
                chkIgnoreCR.IsChecked.ToString,
                chkRound.IsChecked.ToString,
                chkFractions.IsChecked.ToString,
                chkImg.IsChecked.ToString,
                "",
                chkHexa.IsChecked.ToString,
                chkOctal.IsChecked.ToString,
                chkBinary.IsChecked.ToString,
                chkDetail.IsChecked.ToString,
                chkVarNameLen1char.IsChecked.ToString,
                chkNumsInVarname.IsChecked.ToString,
                factor.ToString(MathGlobal8.us),
                cbTimeout.SelectedIndex,
                CInt(Me.WindowState).ToString,
                Me.Left.ToString,
                Me.Top.ToString,
                Me.Width.ToString,
                Me.Height.ToString,
                False.ToString,
                rtbQuery.FontFamily.ToString,
                rtbQuery.FontSize.ToString,
                IIf(rtbQuery.FontWeight = FontWeights.Bold, True, False).ToString,
                IIf(rtbQuery.FontStyle = FontStyles.Italic, True, False).ToString
                }
            ' False for chkUnits.IsChecked.tostring
        Catch ex As Exception
            If bLoaded Then
                MsgBox(ex.ToString)
            End If
        End Try
        Return Join(e1, "|")
    End Function
    Sub parseOptions(ByVal txt As String)
        Try
            If txt = "" Then
                Exit Sub
            End If
            Dim e1() As String = Split(txt, "|")
            chkClear.IsChecked = Boolean.Parse(e1(0))
            chkEng.IsChecked = Boolean.Parse(e1(1))
            chkIgnoreCase.IsChecked = Boolean.Parse(e1(2))
            chkIgnoreCR.IsChecked = Boolean.Parse(e1(3))
            chkRound.IsChecked = Boolean.Parse(e1(4))
            chkFractions.IsChecked = Boolean.Parse(e1(5))
            chkImg.IsChecked = Boolean.Parse(e1(6))
            'chkDegrees.IsChecked = Boolean.Parse(e1(7))
            chkHexa.IsChecked = Boolean.Parse(e1(8))
            chkOctal.IsChecked = Boolean.Parse(e1(9))
            chkBinary.IsChecked = Boolean.Parse(e1(10))
            chkDetail.IsChecked = Boolean.Parse(e1(11))
            chkVarNameLen1char.IsChecked = Boolean.Parse(e1(12))
            chkNumsInVarname.IsChecked = Boolean.Parse(e1(13))
            factor = Single.Parse(e1(14), Globalization.NumberStyles.Float, MathGlobal8.us)
            cbTimeout.SelectedIndex = Int32.Parse(e1(15))
            Select Case Int32.Parse(e1(16))
                Case Windows.WindowState.Maximized
                    Me.WindowState = Windows.WindowState.Maximized
            End Select
            Me.WindowState = Int32.Parse(e1(16))
            Me.Left = Int32.Parse(e1(17))
            Me.Top = Int32.Parse(e1(18))
            Me.Width = Int32.Parse(e1(19))
            Me.Height = Int32.Parse(e1(20))
            'Me.chkUnits.IsChecked = False
            If e1.Length > 21 Then
                'Me.chkUnits.IsChecked = Boolean.Parse(e1(21))
                If e1.Length > 25 Then
                    setFont2(e1(22), Int32.Parse(e1(23)),
                      Boolean.Parse(e1(24)), Boolean.Parse(e1(25)))
                End If
            End If
        Catch ex As Exception
        End Try
    End Sub
    Sub setDefaultOptions()
        Try
            chkClear.IsChecked = True
            chkEng.IsChecked = True
            chkIgnoreCase.IsChecked = False
            chkIgnoreCR.IsChecked = False
            chkRound.IsChecked = True
            chkFractions.IsChecked = True
            chkImg.IsChecked = True
            'chkDegrees.IsChecked = False
            chkHexa.IsChecked = False
            chkOctal.IsChecked = False
            chkBinary.IsChecked = False
            chkDetail.IsChecked = False
            chkVarNameLen1char.IsChecked = True
            chkNumsInVarname.IsChecked = False
            factor = 1.0
            cbTimeout.SelectedIndex = 4
            'chkUnits.IsChecked = False

            setFont2("Courier New", 14, False, False)

            wb.fontName = "Courier New,Courier, Arial"
            wb.fontSize = "14"
        Catch ex As Exception
            If bLoaded Then
                MsgBox(ex.ToString)
            End If
        End Try
    End Sub
    Private Sub ClearAll_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            If infoHelp IsNot Nothing Then
                ' help has been open:
                infoHelp.Stream.Close()
                infoHelp = Nothing
                'wb = New C_WebBrowser(WebBrowser1)
                'wb.Dsp("", "black", False, False, True)
            End If
            wb.Dsp(" ", "")
            'wb.bInit = True
            rtbQuery.Document.Blocks.Clear()
            rtbVars.Document.Blocks.Clear()
            LBHistQuery.Items.Clear()
            lstGo2 = -1
            ReDim Preserve sTbQry(lstGo2),
                            sTbVar(lstGo2), vsResultGo2HTML(lstGo2), vsResultGo3(lstGo2) ', vN(lstGo2)
        Catch ex As Exception

        End Try
    End Sub
    Private Sub Eng(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Incr(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            If factor >= 4 Then
                Exit Sub
            End If
            factor = factor + 0.25
            updateStatusBar()
        Catch ex As Exception

        End Try
    End Sub
    Private Sub Decr(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            If factor <= 0.5 Then
                Exit Sub
            End If
            factor = factor - 15.0 / 100.0
            updateStatusBar()
        Catch ex As Exception

        End Try
    End Sub
    Private Sub Img_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Hexa_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Fractions_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Octal_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Binary_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub Detail(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub IgnoreCase(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)

    End Sub
    Private Sub IgnoreCR(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)

    End Sub
    Private Sub Rounding(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        updateStatusBar()
    End Sub
    Private Sub VarLen(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)

    End Sub
    Private Sub AllowNum(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)

    End Sub
    Private Sub Units(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)

    End Sub
    Private Sub Help(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            infoHelp =
                Application.GetResourceStream(New Uri("/Mates8 User's Guide.htm", UriKind.Relative))
            WebBrowser1.NavigateToStream(infoHelp.Stream)

        Catch ex As Exception

        End Try
    End Sub
    Private Sub About(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Dim w As New About
        w.Owner = Me
        w.ShowDialog()
    End Sub

#End Region

#Region "Calculate"

    Sub Calculate(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Static ar As IAsyncResult = Nothing
        If Not mtx.WaitOne(0) Then
            Exit Sub
        End If
        Try
            bLoaded = False
            bLoaded = True
            If chkClear.IsChecked Then
                n = 1
            End If

            If mP Is Nothing Then
                mP = New matrixParser
            End If
            Dim e1 As String = New TextRange(
                               rtbQuery.Document.ContentStart,
                               rtbQuery.Document.ContentEnd).Text
            e1 = Replace(Trim(e1), vbLf, vbCrLf)
            If Len(e1) = 0 Then
                wb.Dsp(msg8.num(67), "blue", True)
                Exit Try
            End If

            'e1 = Replace(e1, "//", "'")
            'e1 = Replace(e1, vbCrLf, "|@" + vbTab)
            'e1 = Regex.Replace(e1, "\r|\n", vbCrLf)
            'e1 = Replace(e1, "|@" + vbTab, vbCrLf)
            e1 = Replace(e1, vbCrLf + vbCrLf, vbCrLf)
            Dim mc As MatchCollection = Regex.Matches(e1, MathGlobal8.sComment)
            Dim e1b As String = Regex.Replace(e1, MathGlobal8.sComment, "")

            sComments = Split(e1b, "'")
            e1b = sComments(0)
            Dim strQuery As String = e1b
            'Dim e2 As String = Replace(rtbVars.Text, "//", "'")
            'e2 = removeComments(rtbVars.Text)
            Dim e2 As String = New TextRange(
                               rtbVars.Document.ContentStart,
                               rtbVars.Document.ContentEnd).Text
            Dim strRtbvars As String = e2
            If Len(e2) Then
                e2 = Replace(e2, "//", "'")
                e2 = Regex.Replace(e2,
                MathGlobal8.sComment, "")
            End If

            Dim strVarsAndFns As String = e2
            e1 = supressTrailingCRLF(e1)
            Dim sQV(sTbQry.Length - 1) As String
            For i As Int32 = 0 To sTbQry.Length - 1
                Try
                    sQV(i) = sTbQry(i) + sTbVar(i)
                Catch ex As Exception

                End Try
            Next
            'Dim iTb As Int32 = Array.IndexOf(sQV, e1 + supressTrailingCRLF(strVarsAndFns))
            'If iTb > -1 Then GoTo salidaDatos

            ' set options, as rounding, in MathGlobal8 class and
            ' eventually remove blanks or set to
            ' lcase():

            ' Set the configuration:

            ' The following settings have to do
            ' with how the input data will be parsed:
            cfg.bCaseSensitive = Not chkIgnoreCase.IsChecked
            cfg.bIgnoreSpaces = chkIgnoreCR.IsChecked

            ' The next configuration settings affect
            ' on how the output data will be retrieved:
            cfg.bRounding = chkRound.IsChecked
            cfg.bEngNotation = chkEng.IsChecked
            cfg.bFractions = chkFractions.IsChecked
            cfg.bDetail = chkDetail.IsChecked
            cfg.Base = MathGlobal8.outputBase.decimal
            If chkVarNameLen1char.IsChecked Then
                chkNumsInVarname.IsChecked = False
            End If
            cfg.bVarName1Char = chkVarNameLen1char.IsChecked
            cfg.bNumsInVarName = chkNumsInVarname.IsChecked
            'cfg.bUseUnits = chkUnits.IsChecked




            Dim sResult As String = ""

            ' INPUT for matrixParser.Parse()
            ' ==============================
            ' strQuery = the math expression to parse,
            ' for example: strQuery="2*2", "2*x+3*x", "∫(cos(x))dx", "roots(x^16-1)"
            '              or a matrix expression with columns delimited by
            '              semicolons and rows by vbCrLf as "A^-1"
            ' strVarsAndFns = "" or eventualy variables values or functions
            '                for ex. "x=-1" or  "A=2;3" + vbCrLf + "-1;2"
            ' Dim oVars As VarsAndFns = Nothing

            ' OUTPUT:
            ' =======
            ' 1) mP.toString returns the result as a string.
            ' 2) mP.retCjo() returns a complex or, eventually, an array of complex.
            ' 3) When the result is a matrix
            '   xmP.ret.exprMtx.getExpr(row, column) returns the expression
            '   contained at a row and column ((0,0) is the first row and columns)
            '   
            '   mP.ret.exprMtx.getExpr(row, column).IsReal will tell
            '   if the element's content is a real number and 
            '   mP.ret.exprMtx.getExpr(row, column).toDouble its value.
            '   mP.ret.exprMtx.rows gives the number of rows in the matrix
            '   mP.ret.exprMtx.cols gives the # of columns

            ' Example 1. We want the roots of x^16-1 and for that purpose
            ' we equal strQuery="roots(x^16-1)", execute
            ' mP = matrixParser.parse(strQuery,"", nothing)
            ' and, at the output, the roots will be in mP.retCjo(); first, the real
            ' roots (if any) and then the complex (if any):
            ' 
            ' root1:  mp.retCjo(0)  ' = -1 (real)
            ' root2:  mp.retCjo(1)  ' =  1 (real)
            ' root2:  mp.retCjo(2)  ' = -i (complex)
            ' ...
            ' root16: mp.retCjo(15) ' = (0.923879532511287 -i*0.38268343236509) (complex)

            ' Real roots, in mP.retCjo(), are ordered from most negative to most positive.
            ' If root #0 is real and not complex, i.e. the imaginary value is zero, 
            ' mP.retCjo(0).IsReal will be True.


            Dim ts As New TimeSpan(Now.Ticks)


            Dim ts2 As TimeSpan
            sResult = ""

            System.Threading.Thread.Sleep(0)

            cfg.doTimeOut = timeout.never

            mP.cfg = cfg
            mP.cfg.doTimeOut = timeout.whenTimeIsOver

            ' uncomment for a different config set test:
            'Dim cfg2 As New Config
            'cfg2.bDetail = Not cfg.bDetail
            'cfg2.outputFormat = outputMsgFormat.plainText
            'mP.parse(strQuery, strVarsAndFns, oVars, cfg2)
            'MsgBox(mP.ret.ToString)
            'MsgBox(Join(Detall.ToStringDetail(mP.cur, mP, mP.cfg.oDetail), vbCrLf))

            Dim bdetail As Boolean = cfg.bDetail
            'cfg.bDetail = False
            Dim bSkipErr As Boolean = False
            Dim sDetail As String = String.Empty
            If True Then ' 2) Set here to 'False' for debugging purposes
                Dim oParse As New matrixParser.parseObject(
                    mP, strQuery, strVarsAndFns, oVars, cfg)
                'Trace.WriteLine(cfg.ticksStart.ToString)
                th = New System.Threading.Thread(
                   New System.Threading.ParameterizedThreadStart(AddressOf oParse.parse))
                Dim ts3 As New TimeSpan(Now.Ticks + cfg.timeOutms * 10 ^ 4)
                ts2 = New TimeSpan(Now.Ticks - ts.Ticks)
                System.Threading.Thread.Sleep(0)
                th.Start(mP)
                Do While Not th.Join(5)
                    ts2 = New TimeSpan(Now.Ticks - ts.Ticks)
                    Dim ts4 As New TimeSpan(ts3.Ticks - Now.Ticks)
                    If ts4.TotalSeconds < 0 Then
                        Config.cancelID(mP.cfg.ID)
                        System.Threading.Thread.Sleep(0)
                        System.Threading.Thread.Sleep(2000)
                        cfg.doTimeOut = timeout.always
                        sResult = msg8.num(44) + vbCrLf
                        DspCalc(strQuery, strVarsAndFns, sResult)
                        bSkipErr = True
                        Exit Do
                    ElseIf ts2.TotalSeconds AndAlso mP.cfg.ID Then
                    End If
                    System.Threading.Thread.Sleep(0)
                Loop
                th.Abort()
            Else
                For k As Int32 = 1 To 1
                    oVars = Nothing
                    mP.parse(strQuery, strVarsAndFns, oVars, cfg)
                Next
                ts2 = New TimeSpan(Now.Ticks - ts.Ticks)
            End If
            If mP.cfg.ID = 0 Then
                'updateStatusBar(" ...canceled")
                If (mP.retCjo Is Nothing OrElse
                mP.retCjo.Length = 0) AndAlso
                (mP.ret Is Nothing OrElse
                 mP.ret.curExpr Is Nothing) Then
                    Exit Try
                End If
                bSkipErr = True
            Else
                'updateStatusBar("")
            End If
            If Not bSkipErr Then
                If mP.errMsg IsNot Nothing AndAlso
                mP.errMsg.Length Then
                    sResult += mP.errMsg + vbCrLf
                    If (mP.msgHTML.Length AndAlso
                    mP.msgHTML <> mP.errMsg) OrElse
                    (mP.errMsg.Length = 0 AndAlso
                     mP.msgHTML.Length) Then
                        sResult += mP.msgHTML
                    End If
                    'updateStatusBar(mP.errMsg)
                    DspCalc(e1, strVarsAndFns, sResult)
                    Exit Try
                End If

                If mP.msgHTML.Length Then
                    sResult += mP.errMsg + vbCrLf
                    sResult += mP.msgHTML
                    'updateStatusBar(mP.errMsg)
                    DspCalc(e1, strVarsAndFns, sResult)
                    Exit Try
                End If
            End If

            If bdetail Then
                'sDetail = cfg.oDetail.ToStringHTML("navy")
                sDetail = cfg.cur.toStringDetailStack
            End If
            cfg.doTimeOut = timeout.never
            System.Threading.Thread.Sleep(0)
            System.Threading.Thread.Sleep(0)
            cfg.bDetail = bdetail
            For ioutput = 1 To 4
                If ioutput = 1 Then
                ElseIf ioutput = 2 Then
                    If chkHexa.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.hexadecimal
                    Else
                        GoTo sig_i_output
                    End If
                ElseIf ioutput = 3 Then
                    If chkOctal.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.octal
                    Else
                        GoTo sig_i_output
                    End If
                ElseIf ioutput = 4 Then
                    If chkBinary.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.binary
                    Else
                        GoTo sig_i_output
                    End If
                End If

                If ioutput = 1 Then
                ElseIf ioutput = 2 Then
                    If chkHexa.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.hexadecimal
                        sResult += "<br /><h4>Hexadecimal:</h4>"
                    Else
                        GoTo sig_i_output
                    End If
                ElseIf ioutput = 3 Then
                    If chkOctal.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.octal
                        sResult += "<br /><h4>Octal:</h4>"
                    Else
                        GoTo sig_i_output
                    End If
                ElseIf ioutput = 4 Then
                    If chkBinary.IsChecked Then
                        cfg.Base = MathGlobal8.outputBase.binary
                        sResult += "<br /><h4>Binary:</h4>"
                    Else
                        GoTo sig_i_output
                    End If
                End If
                Dim seRet As String = ""
                Dim bIsEq As Boolean = False
                If mP.ret IsNot Nothing AndAlso
                mP.ret.getParser IsNot Nothing Then
                    bIsEq = mP.ret.getParser.cur.bIsEquation
                ElseIf mP.ret Is Nothing Then
                    Exit Try
                End If
                Dim bIsPoly As Boolean = False
                Dim bIsReal As Boolean = False
                graph1 = Nothing
                If mP.ret.curExpr IsNot Nothing Then
                    bIsPoly = mP.ret.curExpr.IsPolynomial
                    bIsReal = mP.ret.curExpr.IsReal
                    Dim vars As VarsAndFns = mP.getVars
                    Dim sVars1() As String = vars.getNamesList
                    If bIsPoly AndAlso sVars1.Length = 1 AndAlso
                    mP.ret.exprMtx.Rows + mP.ret.exprMtx.Cols = 2 Then
                        Try
                            Dim Pa As Polynomial = mP.ret.curExpr.getPolynomial
                            If Not Pa.hasComplexCoeff AndAlso Pa.var.Length = 1 Then
                                graph1 = New Graph(Pa)
                                graph1.draw()
                            End If
                        Catch ex As Exception
                        End Try
                    ElseIf mP.ret.exprMtx.Rows >= 1 AndAlso mP.ret.exprMtx.Cols = 1 Then
                        Try
                            If VarsAndFns.tryParseVariables(strQuery, vars, "") Then
                                Dim expr As Expression = mP.ret.exprMtx.getExpr(0, 0).evalExprToExpr(vars)
                                expr.getAllVars(sVars1)
                                If expr IsNot Nothing AndAlso Not expr.IsComplex Then
                                    graph1 = New Graph()
                                    Dim desde As Double = -1
                                    Dim hasta As Double = 1
                                    Dim paso As Double = 0.1
                                    If mP.retCjo.Length Then
                                        desde = mP.retCjo(0).pRe.ToDouble
                                        hasta = desde + Math.Abs(desde)
                                        desde = desde - Math.Abs(desde)
                                        paso = (hasta - desde) / 10
                                    End If
                                    graph1.draw2(expr.ToString, desde, hasta, paso, cfg.nDecimals, cfg.bRounding)
                                End If
                            End If
                        Catch ex As Exception

                        End Try
                    End If
                End If
                Dim bIsMtx As Boolean = False
                If mP.ret.exprMtx.Cols + mP.ret.exprMtx.Rows <> 2 Then
                    bIsMtx = True
                    If bIsEq AndAlso mP.ret.exprMtx.Cols <> 1 Then
                        sResult += msg8.num(50) ' found columns, expected an equation 
                        'updateStatusBar(sResult)
                        DspCalc(e1, strVarsAndFns, sResult)
                        Exit Try
                    End If
                End If
                sResult += mP.ToString(cfg)
                Dim bOneOrMoreVars As Boolean = (mP.ret.exprMtx.getAllVars.Length >= 1)
                Dim bOneVar As Boolean = (mP.ret.exprMtx.getAllVars.Length = 1)
                If bIsEq AndAlso bOneVar Then
                    seRet += " = 0"
                End If
                Dim sRows() As String = Regex.Split(
                    seRet, MathGlobal8.sRow)
                Dim sCols() As String = Split(
                    Replace(sRows(0), ";", vbTab), vbTab)
                If bIsEq AndAlso bOneOrMoreVars Then
                    If bOneVar AndAlso
                    cfg.bDetail Then
                        Dim Pa As Polynomial = mP.ret.curExpr.getPolynomial
                        If Pa IsNot Nothing AndAlso Pa.PolyResto IsNot Nothing Then
                            seRet = "Detail:" + vbCrLf + Pa.toStringPoly(cfg) + " = 0  =>" + vbCrLf
                            Dim div As Polynomial = New Polynomial(Pa.PolyDivisor)
                            Dim resto As New Polynomial(Pa.PolyResto)
                            Pa.PolyResto = Nothing
                            Pa.PolyDivisor = Nothing
                            Pa *= div
                            Pa += resto
                            mP.ret.curExpr = New Expression(Pa)
                            seRet += Pa.toStringPoly(cfg) + " = 0" + vbCrLf
                            sResult += MathGlobal8.getTable(seRet, "navy")
                        ElseIf mP.soe IsNot Nothing Then
                            seRet = mP.soe.sErrMsg
                        End If
                    End If
                ElseIf bIsEq Then
                    If Not bIsReal OrElse mP.ret.curExpr.toDouble <> 0.0 Then
                        sResult += String.Format("<br /><h3>" + msg8.num(50) + "</h3>",
                                        mP.ret.curExpr.toDouble)
                    Else
                        sResult += MathGlobal8.getTable(seRet, "navy")
                        sResult += "<br /><h3>0 = 0</h3>"
                    End If
                Else
                    Dim common As Expression = Nothing
                    Dim expr As Expression = Nothing
                    Dim commonStr As String = ""
                    Dim Expr1 As Expression = Nothing
                    Dim CommExpr As Expression = Nothing
                    Dim commStr As String = ""
                    If Len(seRet) Then
                        sResult += MathGlobal8.getTable(seRet, "navy")
                    End If
                    'If mP.ret.curExpr.getCommonFactor(cfg, CommExpr, Expr1, commStr) Then
                    '    seRet = " = " + commStr + vbCrLf
                    '    sResult += MathGlobal8.getTable(seRet, "navy")
                    'End If
                    If cfg.bDetail AndAlso (mP.ret.isMatrix OrElse
                    Not mP.ret.curExpr.IsPolynomial) Then
                        sResult += "<br />" + sDetail
                    ElseIf cfg.bDetail Then
                        sResult += "<br />Detail: <br />"
                        sResult += "<br />" + sDetail
                    End If
                End If

sig_i_output:
            Next
            sResult += "<br>" 'Time: " + String.Format("{0:0}", ts2.TotalMilliseconds) + " ms"
            sResult += "<br>"


            'lstGo2 = sTbQry.Length
            'Dim iTb As Int32
            For iTb = 0 To sTbQry.Length - 1
                If sTbQry(iTb) IsNot Nothing Then
                    If sTbQry(iTb).Replace(vbCrLf, "") = e1.Replace(vbCrLf, "") AndAlso
                sTbVar(iTb).Replace(vbCrLf, "") = strRtbvars.Replace(vbCrLf, "") Then
                        Exit For
                    End If
                Else

                End If
            Next
            Dim sImg As String = ""
            If graph1 IsNot Nothing Then
                sImg = graph1.ToBase64
            End If
            e1 = supressTrailingCRLF(e1)
            '            ReDim sQV(sTbQry.Length - 1)
            '            For i As Int32 = 0 To sTbQry.Length - 1
            '                Try
            '                    sQV(i) = sTbQry(i) + sTbVar(i)
            '                Catch ex As Exception

            '                End Try
            '            Next
            '            iTb = Array.IndexOf(sQV, e1 + supressTrailingCRLF(strVarsAndFns))
            'salidaDatos:
            '            If iTb > -1 Then
            '                DspCalc(e1, strVarsAndFns, sResult, iTb, "")
            '                Exit Try

            '            End If
            'DspCalc(e1, strVarsAndFns, sResult, iTb, sImg)

            DspCalc(e1, strVarsAndFns, sResult, -1, sImg)
            lstGo2 = sTbQry.Length
            ReDim Preserve sTbQry(lstGo2), sTbVar(lstGo2), vsResultGo2HTML(lstGo2), vsResultGo3(lstGo2) ', vN(lstGo2)
            'vN(lstGo2) = Me.n
            sTbQry(lstGo2) = e1
            Dim sVars As String = supressTrailingCRLF(strRtbvars)
            sTbVar(lstGo2) = sVars
            If True Then
                Dim doc As New mshtml.HTMLDocument
                Dim htmlDocument As mshtml.IHTMLDocument2 = CType(doc, mshtml.IHTMLDocument2)
                htmlDocument.write("<HTML><HEAD></HEAD><BODY>" + sResult + "</BODY></HTML>")
                htmlDocument.close()
                Dim s As String = doc.body.innerText
                Dim pos As Int32 = InStr(s, "Time:")
                If pos Then
                    s = Microsoft.VisualBasic.Left(s, pos - 1)
                    Do While Microsoft.VisualBasic.Right(s, 2) = vbCrLf
                        s = Microsoft.VisualBasic.Left(s, s.Length - 2)
                    Loop
                End If
                vsResultGo3(lstGo2) = s.Replace(vbCrLf, "|") ' text
            End If

            iCurGo2 = lstGo2
            'lstGo2 += 1
            'Me.n += 1
            If Len(Trim(sVars)) Then
                Dim item As New ComboBoxItem
                item.Content = n.ToString + ") " + Trim(sVars)
                LBHistVars.Items.Add(item)
            End If

        Catch ex As Exception
            Dim s As String = ex.ToString
            Dim s1 As String = s
            'updateStatusBar(ex.Message)
        Finally
            mtx.ReleaseMutex()
        End Try

    End Sub
    Private Sub wb_done(bodyHTML As String) Handles wb.done
        Try
            If lstGo2 < vsResultGo2HTML.Length Then
                vsResultGo2HTML(lstGo2) = bodyHTML  ' HTML
            End If
        Catch ex As Exception
        End Try
    End Sub
    Function supressTrailingCRLF(e1 As String) As String
        Do While Microsoft.VisualBasic.Right(e1, 2) = vbCrLf
            e1 = Mid(e1, 1, Len(e1) - 2)
        Loop
        Do While Microsoft.VisualBasic.Right(e1, 1) = vbLf OrElse Microsoft.VisualBasic.Right(e1, 1) = vbCr
            e1 = Mid(e1, 1, Len(e1) - 1)
        Loop
        e1 = Replace(e1, ">|<", "><")
        Return Trim(Replace(e1, vbCr + vbCrLf, vbCrLf))
    End Function
    Sub DspCalc(ByVal sQuery As String, ByVal sVar As String, ByVal sResult As String, Optional ByVal n1 As Int32 = -1, Optional ByRef sImg As String = "")
        Try
            If infoHelp IsNot Nothing Then
                'WebBrowser1.NavigateToString("")
            End If
            'wb.Dsp("", "", False)
            Dim s As String = ""
            '"<html><body style='font-family:Courier New,Courier,Arial;font-size:12px;'><h5>"
            If n1 = -1 Then
                'n = Me.LBHistQuery.Items.Count + 1
                n = sTbQry.Length + 1
                'wb.Dsp(n.ToString + ") Question:", "black", True)
                s += n.ToString + ") Question:<br />"
                ' record:
                If Len(sQuery) Then
                    ' supress trailing white spaces:
                    Dim sQuery1 As String = sQuery
                    Do While Microsoft.VisualBasic.Right(sQuery1, 2) = vbCrLf
                        sQuery1 = Mid(sQuery1, 1, Len(sQuery1) - 2)
                    Loop
                    Dim item As New ComboBoxItem
                    item.Content = n.ToString + ") " + sQuery1
                    LBHistQuery.Items.Add(item)
                    s += sQuery + vbCrLf
                    sVar = supressTrailingCRLF(sVar)
                    If Trim(sVar).Length Then
                        s += "<br />where<br />" + Replace(sVar, vbCrLf, "|")
                    End If
                    s += "<br />Answer: <br /><div>" + sResult + "</div>"
                End If
            Else
                's += (n1 + 1).ToString + ") Question:<br />"
                's += sQuery + vbCrLf
                's += "<br />Answer: <br /><div>" + sResult + "</div>"
                s = vsResultGo2HTML(n1)
            End If

            'Dim respTbl As String = sResult
            wb.Dsp(s, "blue", False, sImg)

            wb.ZoomWebBrowser(factor)

        Catch ex As Exception
            Dim s As String = ex.ToString
            Dim s1 As String = s
        End Try
    End Sub

#End Region

#Region "Populate"
    Sub populateFnsAndConstants()
        Try
            Dim i As Int32
            Dim vCnts(MathGlobal8.vCntsCaseSen.Length - 1) As String
            Array.Copy(MathGlobal8.vCntsCaseSen, vCnts, vCnts.Length)
            i = vCnts.Length
            ReDim Preserve vCnts(i + MathGlobal8.vCntsCaseNonSen.Length - 1)
            Array.Copy(MathGlobal8.vCntsCaseNonSen, 0,
                       vCnts, i, MathGlobal8.vCntsCaseNonSen.Length)
            Dim oc As New List(Of String)
            Array.Sort(vCnts)
            oc.Insert(0, "---Functions:--")
            For i = 0 To vCnts.Length - 1
                oc.Add(vCnts(i)) ' load constants into the combo 
            Next
            oc.Add("------")
            oc.Add("binary prefix &b")
            oc.Add("octal prefix &o")
            oc.Add("hexadec.prefix &h")
            oc.Add("∫")
            oc.Add("------")

            Dim vFn(MathGlobal8.vFn.Length - 1) As String
            Array.Copy(MathGlobal8.vFn, vFn, vFn.Length)
            Array.Sort(vFn)
            For i = 0 To vFn.Length - 1
                oc.Add(vFn(i)) ' load functions into the combobox
            Next
            Fns.ItemsSource = oc
            Fns.SelectedIndex = 0
        Catch ex As Exception

        End Try
    End Sub

    Sub populateExamples()
        Try
            Dim info As System.Windows.Resources.StreamResourceInfo =
                Application.GetResourceStream(New Uri("/Examples.txt", UriKind.Relative))
            Dim sr As New StreamReader(info.Stream)
            Dim vExamples() As String = Split(sr.ReadToEnd(), vbCrLf)
            sr.Close()
            Dim lst As New List(Of String)
            lst.AddRange(vExamples)
            Examples.ItemsSource = lst
            Examples.SelectedIndex = 0

        Catch ex As Exception

        End Try
    End Sub
    Sub populateSpecialChars()
        Try
            Dim info As System.Windows.Resources.StreamResourceInfo =
                Application.GetResourceStream(New Uri("/SpecialChars.txt", UriKind.Relative))
            Dim sr As New StreamReader(info.Stream)
            Dim vExamples() As String = Split(sr.ReadToEnd(), vbCrLf)
            sr.Close()
            Dim lst As New List(Of String)
            lst.AddRange(vExamples)
            SpecialChars.ItemsSource = lst
            SpecialChars.SelectedIndex = 0
        Catch ex As Exception

        End Try
    End Sub

#End Region

#Region "OnLoad & More events"

    Private Sub OnKeyDownHandler(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.Key = Key.Enter Then
            If Not (Keyboard.IsKeyDown(Key.LeftCtrl) OrElse Keyboard.IsKeyDown(Key.RightCtrl)) Then
                Calculate(Nothing, Nothing)
                e.Handled = True
            ElseIf sender.name = "rtbQuery" Then
                rtbQuery.CaretPosition.InsertLineBreak()
                Dim moveTo As TextPointer = rtbQuery.CaretPosition.GetNextInsertionPosition(LogicalDirection.Forward)
                rtbQuery.CaretPosition = moveTo
                e.Handled = True
            ElseIf sender.name = "rtbVars" Then
                rtbVars.CaretPosition.InsertLineBreak()
                Dim moveTo As TextPointer = rtbVars.CaretPosition.GetNextInsertionPosition(LogicalDirection.Forward)
                rtbVars.CaretPosition = moveTo
                e.Handled = True
            End If
        End If
    End Sub
    Private Sub MainWindow_Initialized(sender As Object, e As System.EventArgs) Handles Me.Initialized
        Try
            If File.Exists(filepathCurrOptions) Then
                Dim fs As New FileStream(filepathCurrOptions, FileMode.Open)
                Dim sr As New StreamReader(fs)
                parseOptions(sr.ReadToEnd)
                sr.Close()
                fs.Close()
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Try
            Me.Title = Mates8.MathGlobal8.NameAndVersion
            populateFnsAndConstants()
            populateExamples()
            populateSpecialChars()
            wb = New C_WebBrowser(WebBrowser1)
            wb.Dsp("", "black", False)
            rtbQuery.Focus()
            updateStatusBar()
            AccessKeyManager.Register("F", Fns)
            AccessKeyManager.AddAccessKeyPressedHandler(Fns, AddressOf AccessKeyPressedEventHandler)
            AccessKeyManager.Register("E", Examples)
            AccessKeyManager.AddAccessKeyPressedHandler(Examples, AddressOf ExamplesKeyPressedEventHandler)
            AccessKeyManager.Register("S", SpecialChars)
            AccessKeyManager.AddAccessKeyPressedHandler(SpecialChars, AddressOf SpecialKeyPressedEventHandler)
            AccessKeyManager.Register("T", cbTimeout)
            AccessKeyManager.AddAccessKeyPressedHandler(cbTimeout, AddressOf TimeoutKeyPressedEventHandler)
            AccessKeyManager.Register("Q", LBHistQuery)
            AccessKeyManager.AddAccessKeyPressedHandler(LBHistQuery, AddressOf QueryKeyPressedEventHandler)
            AccessKeyManager.Register("V", LBHistVars)
            AccessKeyManager.AddAccessKeyPressedHandler(LBHistVars, AddressOf VarsKeyPressedEventHandler)
        Catch ex As Exception

        End Try
    End Sub
    Private Sub AccessKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        Fns.IsDropDownOpen = True
    End Sub
    Private Sub ExamplesKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        Examples.IsDropDownOpen = True
    End Sub
    Private Sub SpecialKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        SpecialChars.IsDropDownOpen = True
    End Sub
    Private Sub TimeoutKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        cbTimeout.IsDropDownOpen = True
    End Sub
    Private Sub QueryKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        LBHistQuery.IsDropDownOpen = True
    End Sub
    Private Sub VarsKeyPressedEventHandler(sender As Object, e As AccessKeyPressedEventArgs)
        LBHistVars.IsDropDownOpen = True
    End Sub
    Private Sub rtbQueryToolTip(sender As Object, e As ToolTipEventArgs)
        Try
            Dim e1 As String = New TextRange(
                   rtbQuery.Document.ContentStart,
                   rtbQuery.Document.ContentEnd).Text
            If Len(Trim(e1)) = 0 OrElse e1 = vbCrLf Then
                If sender.name = "rtbQuery" Then
                    Tooltip1.Text = "Press Enter to calculate;" _
                    + vbCrLf + "'Ctrl+Enter' for a bnew line."
                    'Tooltip1.Visibility = Windows.Visibility.Visible
                    rtbTooltip1.Visibility = Windows.Visibility.Visible
                    rtbTooltip2.Visibility = Windows.Visibility.Collapsed
                Else
                    Tooltip2.Text = "Press Enter to calculate;" _
                    + vbCrLf + "'Ctrl+Enter' for a new line."
                    rtbTooltip1.Visibility = Windows.Visibility.Collapsed
                    rtbTooltip2.Visibility = Windows.Visibility.Visible
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub
    Private Sub record_edit(sender As Object, e As RoutedEventArgs)
        Dim w As New Record(Me, sTbQry, sTbVar, Me.vsResultGo2HTML, Me.vsResultGo3)
        w.Owner = Me
        w.ShowDialog()
    End Sub
    Public Sub setsTbQrysTbvar(sTbQry2, sTbVar2, sResult2HTML, sResult3)
        sTbQry = sTbQry2
        sTbVar = sTbVar2
        vsResultGo2HTML = sResult2HTML
        vsResultGo3 = sResult3
        iCurGo2 = sTbQry.Length - 1
    End Sub
    Private Sub Output_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Dim outputWin = New Output(wb.getText)
        outputWin.Title = "Current output"
        outputWin.Owner = Me
        outputWin.ShowDialog()
    End Sub
    Private Sub Output_All_Executed(sender As System.Object, e As System.Windows.Input.ExecutedRoutedEventArgs)
        Try
            Dim s As String = ""
            For i = 0 To sTbVar.Length - 1
                Dim s1 As String = Replace_BR_and_Others(sTbQry(i))
                s1 = Replace(s1, "|", vbCrLf)
                s += (i + 1).ToString + ") Question: " + s1 + vbCrLf
                ' functions:
                s1 = Replace_BR_and_Others(sTbVar(i))
                s1 = Replace(s1, "|", vbCrLf)
                If Len(s1) Then
                    s += "where: " + s1 + vbCrLf
                End If
                ' answer:
                s1 = Replace_BR_and_Others(vsResultGo3(i))
                s1 = Replace(s1, "|", vbCrLf)
                s += "Answer: " + s1 + vbCrLf
                s += " ---------------------" + vbCrLf
            Next
            Dim outputWin = New Output(s)
            outputWin.Title = "Output All"
            outputWin.Owner = Me
            outputWin.ShowDialog()
        Catch ex As Exception

        End Try
    End Sub



#End Region

#Region "selectionChanged"
    Private Sub Fns_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles Fns.SelectionChanged
        Try
            Dim cbExamples As ComboBox = Examples

            If cbExamples.SelectedIndex > -1 Then
                'chkIgnoreCase.Checked = False
                Dim bIgnoreSpaces As Boolean = Me.chkIgnoreCR.IsChecked
                chkIgnoreCR.IsChecked = False
                cfg.bIgnoreSpaces = False
                cfg.bVarName1Char = False
                Dim e1 As String = ""

                e1 = cbExamples.Items(cbExamples.SelectedIndex)
                e1 = Trim(e1)
                If Len(e1) = 0 Then
                    Exit Sub
                End If
                If Len(e1) > 3 AndAlso
                Mid(e1, 1, 3) = "---" Then
                    Exit Sub
                End If
                e1 = Replace(e1, "&amp;", "&")
                Dim e3() As String = Split(e1, "?")

                rtbQuery.Document.Blocks.Clear()
                rtbQuery.Document.Blocks.Add(New Paragraph(New Run(e3(0))))
                rtbVars.Document.Blocks.Clear()
                Dim strVars As String = String.Empty
                If e3.Length > 1 Then
                    For i As Int32 = 1 To e3.Length - 1
                        'rtbVars.Text += e3(i)
                        strVars += e3(i)
                    Next
                    'rtbVars.Text = Replace(rtbVars.Text, "|", vbCrLf)
                    strVars = Replace(strVars, "|", vbCrLf)
                End If
                rtbVars.Document.Blocks.Clear()
                rtbVars.Document.Blocks.Add(New Paragraph(New Run(strVars)))
                Dim bH As Boolean = chkHexa.IsChecked
                Dim bO As Boolean = chkOctal.IsChecked
                Dim bB As Boolean = chkBinary.IsChecked
                'Dim bUnits As Boolean = chkUnits.IsChecked
                chkHexa.IsChecked = False
                chkOctal.IsChecked = False
                chkBinary.IsChecked = False
                If InStr(e1, "&h") Then
                    chkHexa.IsChecked = True
                    chkOctal.IsChecked = True
                    chkBinary.IsChecked = True
                Else
                End If
                If InStr(e1, "Xc=") Then
                    chkVarNameLen1char.IsChecked = False
                    'chkUnits.IsChecked = True
                Else
                    chkVarNameLen1char.IsChecked = True
                End If
                'chkUnits.IsChecked = False
                wb.clear()
                Calculate(Nothing, Nothing)
                chkHexa.IsChecked = bH
                chkOctal.IsChecked = bO
                chkBinary.IsChecked = bB
                cfg.bIgnoreSpaces = bIgnoreSpaces
                chkIgnoreCR.IsChecked = bIgnoreSpaces
                'chkUnits.IsChecked = bUnits
            End If

        Catch ex As Exception
        End Try
    End Sub
    Private Sub Examples_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles Examples.SelectionChanged
        showExample(Examples.SelectedItem)
    End Sub
    Private Sub Examples_PreviewKeyDown(sender As System.Object, e As System.Windows.Input.KeyEventArgs)
        Try
            showExample(e.OriginalSource.content)
        Catch ex As Exception
        End Try
    End Sub
    Sub showExample(exampleStr As String)
        Try
            'chkIgnoreCase.IsChecked = False
            Dim bIgnoreSpaces As Boolean = chkIgnoreCR.IsChecked
            chkIgnoreCR.IsChecked = False
            cfg.bIgnoreSpaces = False
            cfg.bVarName1Char = False
            Dim e1 As String = ""

            e1 = exampleStr ' Examples.Items(index)
            e1 = Trim(e1)
            If Len(e1) = 0 Then
                Exit Sub
            End If
            If Len(e1) > 3 AndAlso
            Mid(e1, 1, 3) = "---" Then
                Exit Sub
            End If
            e1 = Replace(e1, "&amp;", "&")
            Dim e3() As String = Split(e1, "?")
            rtbQuery.Document.Blocks.Clear()
            rtbQuery.Document.Blocks.Add(New Paragraph(New Run(e3(0))))
            Dim sVars As String = String.Empty
            If e3.Length > 1 Then
                For i As Int32 = 1 To e3.Length - 1
                    'rtbVars.Text += e3(i)
                    sVars += e3(i)
                Next
                'rtbVars.Text = Replace(rtbVars.Text, "|", vbCrLf)
                sVars = Replace(sVars, "|", vbCrLf)
            End If
            rtbVars.Document.Blocks.Clear()
            rtbVars.Document.Blocks.Add(New Paragraph(New Run(sVars)))
            Dim bH As Boolean = chkHexa.IsChecked
            Dim bO As Boolean = chkOctal.IsChecked
            Dim bB As Boolean = chkBinary.IsChecked
            'Dim bUnits As Boolean = chkUnits.IsChecked
            chkHexa.IsChecked = False
            chkOctal.IsChecked = False
            chkBinary.IsChecked = False
            If InStr(e1, "&h") Then
                chkHexa.IsChecked = True
                chkOctal.IsChecked = True
                chkBinary.IsChecked = True
            Else
            End If
            If InStr(e1, "Xc=") Then
                chkVarNameLen1char.IsChecked = False
                'chkUnits.IsChecked = True
            Else
                chkVarNameLen1char.IsChecked = True
            End If
            'chkUnits.IsChecked = False
            Calculate(Nothing, Nothing)
            chkHexa.IsChecked = bH
            chkOctal.IsChecked = bO
            chkBinary.IsChecked = bB
            cfg.bIgnoreSpaces = bIgnoreSpaces
            chkIgnoreCR.IsChecked = bIgnoreSpaces
            'chkUnits.IsChecked = bUnits
            updateStatusBar()
        Catch ex As Exception

        End Try

    End Sub
    Private Sub LBHistQuery_SelectionChanged(sender As System.Object, e As System.Windows.Controls.SelectionChangedEventArgs)
        Try
            Dim exampleStr As String = sender.selecteditem.content
            Dim pos As Int32 = InStr(exampleStr, ")")
            exampleStr = Mid(exampleStr, pos + 2)
            exampleStr = Regex.Replace(exampleStr, "^(\r\n)", "")
            exampleStr = Regex.Replace(exampleStr, "(\r\n)$", "")
            rtbQuery.Document.Blocks.Clear()
            rtbQuery.Document.Blocks.Add(New Paragraph(New Run(exampleStr)))
        Catch ex As Exception

        End Try
    End Sub
    Private Sub LBHistVars_SelectionChanged(sender As System.Object, e As System.Windows.Controls.SelectionChangedEventArgs)
        Try
            Dim varsStr As String = sender.selecteditem.content
            Dim pos As Int32 = InStr(varsStr, ")")
            varsStr = Mid(varsStr, pos + 1)
            varsStr = Regex.Replace(varsStr, "^(\r\n)", "")
            varsStr = Regex.Replace(varsStr, "(\r\n)$", "")
            rtbVars.Document.Blocks.Clear()
            rtbVars.Document.Blocks.Add(New Paragraph(New Run(varsStr)))
        Catch ex As Exception

        End Try

    End Sub
    Private Sub SpecialChars_SelectionChanged(sender As System.Object, e As System.Windows.Controls.SelectionChangedEventArgs)
        If sender.selectedindex > 0 Then
            rtbQuery.Document.Blocks.Add(New Paragraph(New Run(sender.selecteditem)))
        End If
    End Sub
    Private Sub cbTimeout_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles cbTimeout.SelectionChanged
        Try
            Dim str As String = cbTimeout.SelectedItem.content
            Select Case LCase(str)
                Case "never" : cfg.doTimeOut = timeout.never
                Case Else
                    If InStr(str, "m") Then
                        str = Replace(str, "m", "")
                        Dim db As Double
                        If Double.TryParse(str, db) Then
                            cfg.timeOutms = db * 60 * 1000
                        End If
                    ElseIf InStr(str, "s") Then
                        str = Replace(str, "s", "")
                        Dim db As Double
                        If Double.TryParse(str, db) Then
                            cfg.timeOutms = db * 1000
                        End If
                    End If
            End Select
        Catch ex As Exception

        End Try
    End Sub

#End Region

#Region "File menu"

    'Sub OpenFile(bAppend As Boolean)
    '    Dim fs As FileStream = Nothing
    '    'Dim sr As StreamReader = Nothing
    '    Try

    '        Dim OpenFileDialog1 As New Microsoft.Win32.OpenFileDialog
    '        OpenFileDialog1.Filter = "Text files (.txt)|*.txt|All files (*.*)|*.*"
    '        OpenFileDialog1.FileName = curFileName
    '        Dim bOk As Boolean = OpenFileDialog1.ShowDialog
    '        If bOk <> True Then
    '            Exit Sub
    '        End If
    '        fs = New FileStream(OpenFileDialog1.FileName, FileMode.Open)
    '        Dim s As String
    '        Using sr As New StreamReader(fs, True)
    '            s = sr.ReadToEnd
    '        End Using

    '        Try
    '            'Dim doc As New mshtml.HTMLDocument
    '            'Dim htmlDocument As mshtml.IHTMLDocument2 = CType(doc, mshtml.IHTMLDocument2)
    '            'htmlDocument.write(s)
    '            'htmlDocument.close()

    '            Dim vTbl() As String = Split(s, "<!-- QUESTION -->")
    '            Dim iv As Int32 = 1
    '            lstGo2 = 0
    '            Dim s1 As String = wb.head
    '            For iTbl As Int32 = 1 To vTbl.Length - 1
    '                Dim vLines() As String = Split(vTbl(iTbl), vbCrLf)
    '                ReDim Preserve sTbQry(lstGo2),
    '                        sTbVar(lstGo2), vsResultGo2HTML(lstGo2), vsResultGo3(lstGo2) ', vN(lstGo2)
    '                Dim q() As String = Split(vLines(0), "Question (" + (lstGo2 + 1).ToString + ") ") ' suprimir: Question(n)
    '                sTbQry(lstGo2) = q(1)
    '                sTbVar(lstGo2) = Split(vLines(1), "Variables: ")(1)
    '                vsResultGo3(lstGo2) = Split(vLines(2), "Answer: ")(1)
    '                Dim vs() As String = Split(vLines(3), "AnswerHTML: ")
    '                s1 += vs(1)
    '                vsResultGo2HTML(lstGo2) = vs(1)

    '                lstGo2 += 1
    '            Next
    '            wb.Dsp(s1, "")
    '        Catch ex As Exception

    '        End Try
    '    Catch ex As Exception
    '        MsgBox("Could not read the file or the file is empty.")
    '        Dim s1 As String = ex.ToString
    '        Dim s2 As String = s1
    '        MsgBox(s1)
    '    Finally
    '    End Try
    'End Sub
    Sub OpenHTMLFile(bAppend As Boolean)
        Dim fs As FileStream = Nothing
        Try

            Dim OpenFileDialog1 As New Microsoft.Win32.OpenFileDialog
            OpenFileDialog1.Filter = "HTML files (.htm)|*.htm;*.html|All files (*.*)|*.*"
            OpenFileDialog1.FileName = curFileName
            Dim bOk As Boolean = OpenFileDialog1.ShowDialog
            If bOk <> True Then
                Exit Sub
            End If
            Dim r As MessageBoxResult = MessageBoxResult.Cancel
            If sTbVar.Length Then
                r = MessageBox.Show("Append file data to existing data?", "Append file",
                    MessageBoxButton.YesNoCancel)
                If r = MessageBoxResult.Cancel Then
                    Exit Sub
                End If
            End If
            fs = New FileStream(OpenFileDialog1.FileName, FileMode.Open)
            Dim s As String
            Using sr As New StreamReader(fs, True)
                s = sr.ReadToEnd
            End Using

            Try
                'Dim doc As New mshtml.HTMLDocument
                'Dim htmlDocument As mshtml.IHTMLDocument2 = CType(doc, mshtml.IHTMLDocument2)
                'HTMLDocument.write(s)
                'HTMLDocument.close()

                Dim vTbl() As String = Split(s, "<!-- QUESTION ")
                Dim iv As Int32 = 1
                lstGo2 = IIf(r = MessageBoxResult.No, 0, sTbVar.Length)
                Dim s1 As String = ""
                For iTbl As Int32 = 1 To vTbl.Length - 1
                    Dim vLines() As String = Split(vTbl(iTbl), vbCrLf)
                    ReDim Preserve sTbQry(lstGo2),
                            sTbVar(lstGo2), vsResultGo2HTML(lstGo2), vsResultGo3(lstGo2) ', vN(lstGo2)
                    sTbQry(lstGo2) = vLines(1) ' question
                    sTbVar(lstGo2) = vLines(2) ' variables
                    vsResultGo3(lstGo2) = vLines(3) ' answer
                    ' HTML answer:
                    Dim pos As Int32 = InStr(vLines(4), "<")
                    vsResultGo2HTML(lstGo2) = Mid(vLines(4), pos)
                    s1 += Mid(vLines(4), pos)
                    lstGo2 += 1
                Next
                wb.Dsp(s1, "")
            Catch ex As Exception

            End Try
            iCurGo2 = 0
        Catch ex As Exception
            MsgBox("Could not read the file or the file is empty.")
            Dim s1 As String = ex.ToString
            Dim s2 As String = s1
            MsgBox(s1)
        Finally
        End Try
    End Sub
    Function td(m As RegularExpressions.Match) As String
        Return ";"
    End Function
    Function tr(m As RegularExpressions.Match) As String
        Return "|"
    End Function
    'Private Sub Save()
    '    Dim fs As FileStream = Nothing
    '    'Dim sw As StreamWriter = Nothing
    '    Try
    '        Dim SaveFileDialog1 As New Microsoft.Win32.SaveFileDialog
    '        SaveFileDialog1.Filter = "Text files (.txt)|*.txt|All files (*.*)|*.*"
    '        SaveFileDialog1.FileName = curFileName
    '        Dim r As Boolean = SaveFileDialog1.ShowDialog()
    '        If r <> True Then
    '            Exit Sub
    '        End If
    '        Dim path As String = SaveFileDialog1.FileName
    '        fs = New FileStream(path, FileMode.Create)
    '        Using sw As New StreamWriter(fs)
    '            Dim i As Int32
    '            Dim s As String = "<!doctype html>" + vbCrLf
    '            For i = 0 To sTbQry.Length - 1
    '                s += "<!-- QUESTION " + vbCrLf
    '                s += "Question (" + (i + 1).ToString + ") " + Replace_BR_and_Others(sTbQry(i)) + +vbCrLf
    '                s += "Variables: " + Replace_BR_and_Others(sTbVar(i)) + vbCrLf
    '                s += "Answer: " + Replace_BR_and_Others(vsResultGo3(i)) + vbCrLf + " -->"
    '                Dim s1 As String = Replace_BR_and_Others(vsResultGo2HTML(i))
    '                s += "AnswerHTML: " + Replace(s1, ">|<", "><") + vbCrLf
    '            Next
    '            s += "</div></body></html>" + vbCrLf
    '            sw.Write(s)
    '        End Using

    '    Catch ex As Exception
    '    End Try
    'End Sub
    Private Sub SaveHTML()
        Dim fs As FileStream = Nothing
        Try
            Dim SaveFileDialog1 As New Microsoft.Win32.SaveFileDialog
            SaveFileDialog1.Filter = "HTML files (.htm)|*.htm;*.html|All files (*.*)|*.*"
            SaveFileDialog1.FileName = curFileName
            Dim r As Boolean = SaveFileDialog1.ShowDialog()
            If r <> True Then
                Exit Sub
            End If
            Dim path As String = SaveFileDialog1.FileName
            fs = New FileStream(path, FileMode.Create)
            Using sw As New StreamWriter(fs)
                Dim i As Int32
                Dim s As String = ""
                s += wb.head
                s += "<body><div id=""div1"">"
                For i = 0 To sTbQry.Length - 1
                    s += "<!-- QUESTION " + vbCrLf
                    ' question:
                    s += Replace_BR_and_Others(sTbQry(i)) + vbCrLf
                    ' functions:
                    s += Replace_BR_and_Others(sTbVar(i)) + vbCrLf
                    ' answer:
                    s += Replace_BR_and_Others(vsResultGo3(i)) + vbCrLf + " -->"
                    ' answer HTML:
                    Dim s1 As String = Replace_BR_and_Others(vsResultGo2HTML(i))
                    s1 = Regex.Replace(s1, "\d+\) Question", (i + 1).ToString + ") Question")
                    s += Replace(s1, ">|<", "><") + vbCrLf
                Next
                s += "</div>"
                s += "<div id=""last""></div>" + vbCrLf
                s += "</body></html>" + vbCrLf
                sw.Write(s)
            End Using

        Catch ex As Exception
        End Try
    End Sub
    Function Replace_BR_and_Others(s1 As String) As String
        Try
            s1 = Replace(s1, vbCrLf + vbCrLf, vbCrLf)
            s1 = Replace(Replace(s1, "<br />", "|"), vbCrLf, "|")
            s1 = Replace(s1, "<BR><BR>", "")
            s1 = Replace(s1, vbTab, ";")
            s1 = Replace(s1, ",", ";")
            s1 = Replace(s1, "base64;", "base64,")
        Catch ex As Exception

        End Try
        Return s1
    End Function
#End Region

#Region "statusBar"
    Sub updateStatusBar()
        lblHexa.TextDecorations = IIf(chkHexa.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblOctal.TextDecorations = IIf(chkOctal.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblBinary.TextDecorations = IIf(chkBinary.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblRound.TextDecorations = IIf(chkRound.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblFractions.TextDecorations = IIf(chkFractions.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblEng.TextDecorations = IIf(chkEng.IsChecked, Nothing, TextDecorations.Strikethrough)
        lblImg.Text = IIf(chkImg.IsChecked, "i", "j")
        Try
            Dim scale As New ScaleTransform(factor, factor)
            rtbQuery.LayoutTransform = scale
            rtbVars.LayoutTransform = scale
            wb.ZoomWebBrowser(factor)
            lblPje.Text = Math.Round(factor * 100).ToString + "%"
        Catch ex As Exception

        End Try
    End Sub
    Private Sub stBar(sender As Object, e As RoutedEventArgs)
        Try
            Dim nom As String = Mid(CStr(sender.name), 4)
            Select Case LCase(nom)
                Case "lt" : gotoPrevious()
                Case "gt" : gotoNext()
                Case "clear"
                    Try
                        If infoHelp IsNot Nothing Then
                            ' help has been open:
                            infoHelp.Stream.Close()
                            infoHelp = Nothing
                            'wb = New C_WebBrowser(WebBrowser1)
                            'wb.Dsp("", "black", False, False, True)
                        End If
                        wb.Dsp(" ", "")
                        'wb.bInit = True
                        rtbQuery.Document.Blocks.Clear()
                        rtbVars.Document.Blocks.Clear()
                        'LBHistQuery.Items.Clear()
                    Catch ex As Exception

                    End Try

                Case "hexa" : chkHexa.IsChecked = Not chkHexa.IsChecked
                Case "octal" : chkOctal.IsChecked = Not chkOctal.IsChecked
                Case "binary" : chkBinary.IsChecked = Not chkBinary.IsChecked
                Case "round" : chkRound.IsChecked = Not chkRound.IsChecked
                Case "fractions" : chkFractions.IsChecked = Not chkFractions.IsChecked
                Case "eng" : chkEng.IsChecked = Not chkEng.IsChecked
                    'case "img" -->see stBarImg_MouseLeftButtonDown()
                Case "pje"


            End Select
            updateStatusBar()
        Catch ex As Exception

        End Try
    End Sub
    Sub zoom(sender As Object, e As RoutedEventArgs)
        Try
            Dim sNum As String = sender.header
            sNum = Mid(sNum, 1, 3)
            If sNum.Chars(0) = " " Then sNum = Mid(sNum, 2)
            Dim db As Double
            If Double.TryParse(sNum, db) Then
                factor = db / 100
                updateStatusBar()
            End If
        Catch ex As Exception

        End Try
    End Sub
    Private Sub stBarImg_MouseLeftButtonDown(sender As Object, e As System.Windows.Input.MouseButtonEventArgs) Handles stBarImg.MouseLeftButtonDown
        chkImg.IsChecked = Not chkImg.IsChecked
        updateStatusBar()
    End Sub
#End Region

#Region "GoTo"

    Sub dspGo2()
        If chkClear.IsChecked Then
            wb.clear()
        End If
        rtbQuery.Document.Blocks.Clear()
        rtbQuery.Document.Blocks.Add(New Paragraph(New Run(Me.sTbQry(iCurGo2))))
        rtbVars.Document.Blocks.Clear()
        rtbVars.Document.Blocks.Add(New Paragraph(New Run(Me.sTbVar(iCurGo2))))
        DspCalc(Me.sTbQry(iCurGo2), Me.sTbVar(iCurGo2), Me.vsResultGo2HTML(iCurGo2), iCurGo2) ' vN(iCurGo2))
        updateStatusBar()
    End Sub

#End Region

#Region "ContextMenu"
    Sub fontVars()
        setfont()
    End Sub
    Sub font()
        setfont()
    End Sub
    Sub setfont()
        Try
            Dim f As New System.Drawing.Font("Courier New", 14)
            Dim fD As New System.Windows.Forms.FontDialog
            fD.Font = f
            Dim result As Boolean = fD.ShowDialog()
            If result <> True Then
                Exit Sub
            End If
            Dim dst As Control = rtbVars
            dst.FontFamily = New FontFamily(fD.Font.Name)
            dst.FontSize = fD.Font.Size * 96.0 / 72.0
            dst.FontWeight = IIf(fD.Font.Bold, FontWeights.Bold, FontWeights.Regular)
            dst.FontStyle = IIf(fD.Font.Italic, FontStyles.Italic, FontStyles.Normal)

            dst = rtbQuery
            dst.FontFamily = New FontFamily(fD.Font.Name)
            dst.FontSize = fD.Font.Size * 96.0 / 72.0
            dst.FontWeight = IIf(fD.Font.Bold, FontWeights.Bold, FontWeights.Regular)
            dst.FontStyle = IIf(fD.Font.Italic, FontStyles.Italic, FontStyles.Normal)

            wb.fontName = fD.Font.Name
            wb.fontSize = fD.Font.Size
            wb.fontBold = fD.Font.Bold
            wb.fontItalic = fD.Font.Italic
            'Dim tdc As New TextDecorationCollection()
            'If fD.Font.Underline Then tdc.Add(TextDecorations.Underline)
            'If f.Strikeout Then tdc.Add(TextDecorations.Strikethrough)
            'Me.TextDecorations = tdc

        Catch ex As Exception

        End Try
    End Sub
    Sub setFont2(family As String, fontSize As Int32, bold As Boolean, italic As Boolean)
        Try
            With rtbQuery
                .FontFamily = New FontFamily(family)
                .FontSize = fontSize
                .FontWeight = IIf(bold, FontWeights.Bold, FontWeights.Regular)
                .FontStyle = IIf(italic, FontStyles.Italic, FontStyles.Normal)
            End With
            With rtbVars
                .FontFamily = New FontFamily(family)
                .FontSize = fontSize
                .FontWeight = IIf(bold, FontWeights.Bold, FontWeights.Regular)
                .FontStyle = IIf(italic, FontStyles.Italic, FontStyles.Normal)
            End With
            wb.fontName = family
            wb.fontSize = fontSize
            wb.fontBold = bold
            wb.fontItalic = italic
        Catch ex As Exception

        End Try
    End Sub
    Sub ClearQuery()
        rtbQuery.Document.Blocks.Clear()
    End Sub
    Sub ClearAndPasteQuery()
        rtbQuery.Document.Blocks.Clear()
        rtbQuery.Paste()
    End Sub
    Sub copyQuery()
        rtbQuery.Copy()
    End Sub
    Sub pasteQuery()
        rtbQuery.Paste()
    End Sub
    Sub gotoNext()
        ' Go to next calc.
        'Me.lstGo2 = Me.sTbQry.Length
        If Me.iCurGo2 < sTbQry.Length - 1 Then
            Me.iCurGo2 += 1
            dspGo2()
        End If
    End Sub
    Sub gotoPrevious()
        ' Go to previous calc.
        If Me.iCurGo2 > 0 Then
            Me.iCurGo2 -= 1
            dspGo2()
        Else
            Me.iCurGo2 = 0
        End If
    End Sub
    Sub populateLBQuery()
        Try
            lbGoTo.Items.Clear()
            For i As Int32 = 0 To sTbQry.Length - 1
                Dim item As New ListBoxItem
                item.Content = sTbQry(i) + "@@" + sTbVar(i)
                lbGoTo.Items.Add(item)
            Next
        Catch ex As Exception

        End Try
    End Sub
    Private Sub lbGoTo_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles lbGoTo.SelectionChanged
        Try
            Me.iCurGo2 = lbGoTo.SelectedIndex
            dspGo2()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub CommandBinding_Executed(sender As Object, e As ExecutedRoutedEventArgs)

    End Sub

    Sub ClearVars()
        rtbVars.Document.Blocks.Clear()
    End Sub
    Sub ClearAndPasteVars()
        rtbVars.Document.Blocks.Clear()
        rtbVars.Paste()
    End Sub
    Sub copyVars()
        rtbVars.Copy()
    End Sub
    Sub pasteVars()
        rtbVars.Paste()
    End Sub



#End Region

End Class
